package com.picfun.chargercontroller;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.Toast;
import java.io.OutputStream;
import java.io.InputStream;

/***************** アクティビティの宣言 ********************/
public class ChargerController extends Activity {
	/**** クラス定数宣言定義 ****/
	public static final int CONNECTDEVICE = 1;
	public static final int ENABLEBLUETOOTH = 2;
	/** Bluetoothインスタンス定数 **/
	private static BluetoothAdapter BTadapter;
	private static BluetoothClient BTclient;	
	/** バッファ、一般変数定義 **/
	private static byte[] RcvPacket = new byte[32];			// 受信バッファ
	private static byte[] SndPacket = new byte[32];			// 送信バッファ
	private static int[] ChargeVolt = new int[1560];
	private static int[] ChargeCurrent = new int[1560];
	private static int[] DischargeVolt = new int[1560];
	private static int[] DischargeCurrent = new int[1560];
	private static byte[] FileData = new byte[12482];
	private static int i, j, Index, temp;
	private static float fTemp;
	/** クラス変数、定数の宣言 **/
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button Select, Charge, Save, Read, Delete;
	private static TextView text, text1, text2, text3;
	private static EditText edText, fileText;
	private static MyView graph;
	
    /************ 最初に実行する関数 *******************************/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
		/** フルスクリーンの指定 **/
		getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);          
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);    
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        	/** サブレイアウト **/
        	LinearLayout layout2 = new LinearLayout(this);
            layout2.setOrientation(LinearLayout.VERTICAL);
            layout.setBackgroundColor(Color.BLACK);             
            layout2.setGravity(Gravity.LEFT); 
             	/** 見出しテキスト表示 **/             
    	        text = new TextView(this);
    	        text.setLayoutParams(new LinearLayout.LayoutParams(290,WC));
    	        text.setTextSize(22f);
       	        text.setTextColor(Color.MAGENTA);    	        
    	        text.setText("充放電モニタ");
    	        layout2.addView(text); 
    	        /** 接続ボタン作成 **/
    	    	LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(250, 85);
      	    	params.setMargins(0, 20, 0, 0);     	    	
    	    	Select = new Button(this);
    	    	Select.setBackgroundColor(Color.CYAN);
    	    	Select.setTextColor(Color.BLACK);
    	    	Select.setTextSize(20f);
    	    	Select.setText("端末接続");    	
    	    	Select.setLayoutParams(params);	
    	    	layout2.addView(Select);
    	    	/** メッセージ表示 **/
    	    	LinearLayout.LayoutParams params3 = new LinearLayout.LayoutParams(290, WC);
      	    	params3.setMargins(10,10, 0,0);   	    	
    	    	text1 = new TextView(this);
      	    	text1.setTextColor(Color.WHITE);    	    	
      	        text1.setLayoutParams(params3);
      	        text1.setTextSize(18f);
      	        text1.setText("接続状態");
      	        layout2.addView(text1); 
    	    	/** モニタ開始ボタン **/
    	    	
      	    	Charge = new Button(this);						// モニタ開始ボタン
      	    	Charge.setBackgroundColor(Color.YELLOW);
      	    	Charge.setTextSize(20f);
       	    	Charge.setText("モニタ開始");
      	    	Charge.setLayoutParams(params);
      	    	layout2.addView(Charge);
      	    	
      	    	/** ファイル読み書きメッセージ **/
    	    	LinearLayout.LayoutParams params4 = new LinearLayout.LayoutParams(290, WC); 
      	    	params4.setMargins(0,20, 0,0);       	    	
      	    	text3 = new TextView(this);
      	    	text3.setTextColor(Color.CYAN);
      	    	text3.setLayoutParams(params4);
      	    	text3.setTextSize(18f);
      	    	text3.setText("【ファイル操作】");
      	    	layout2.addView(text3);
      	    	/** ファイル名入力ボックス **/
    	    	LinearLayout.LayoutParams params6 = new LinearLayout.LayoutParams(280, WC); 
      	    	params6.setMargins(0,0, 0,0);       	    	
      	    	edText = new EditText(this);
      	    	edText.setTextColor(Color.WHITE);
      	    	edText.setTextSize(20f);
      	    	edText.setText("data.txt");
      	    	edText.setLayoutParams(params6);
      	    	layout2.addView(edText);
      	    	
    	    	/** 保存ボタン **/ 
    	    	LinearLayout.LayoutParams params2 = new LinearLayout.LayoutParams(250, 85); 
      	    	params2.setMargins(0,0, 0,0);       	    	
      	    	Save = new Button(this);						// 
      	    	Save.setBackgroundColor(Color.MAGENTA);
      	    	Save.setTextSize(20f);
       	    	Save.setText("データ保存");
      	    	Save.setLayoutParams(params2);
      	    	layout2.addView(Save);   
    	    	/** データ読み出しボタン  **/  	    	
      	    	Read = new Button(this);						// 
      	    	Read.setBackgroundColor(Color.GREEN);
      	    	Read.setTextSize(20f);
       	    	Read.setText("読み出し");
      	    	Read.setLayoutParams(params);
      	    	layout2.addView(Read);
      	    	/** ファイル削除ボタン　**/
      	    	Delete = new Button(this);
      	    	Delete.setBackgroundColor(Color.LTGRAY);
      	    	Delete.setTextSize(20f);
       	    	Delete.setText("削除");
      	    	Delete.setLayoutParams(params);
      	    	layout2.addView(Delete);
    	    	/** 汎用メッセージボックス生成 **/     	    	
    	    	LinearLayout.LayoutParams params5 = new LinearLayout.LayoutParams(290, 50);
      	    	params5.setMargins(5, 10, 0,0);	        
      	        text2 = new TextView(this);
      	    	text2.setTextColor(Color.GRAY);      	        
             	text2.setTextSize(16f);
      	        text2.setLayoutParams(params5);
    	        text2.setText("メッセージ");
    	        layout2.addView(text2);      	    	
      	    	/*** ファイル一覧表示 *****/
    	    	LinearLayout.LayoutParams params7 = new LinearLayout.LayoutParams(280, 280); 
      	    	params7.setMargins(0,0, 0,0);       	    	
      	    	fileText = new EditText(this);
     	    	fileText.setTextColor(Color.BLACK);
     	    	fileText.setBackgroundColor(Color.WHITE);
      	    	fileText.setTextSize(16f);
      	    	fileText.setText("ファイル一覧");
      	    	fileText.setLayoutParams(params7);
      	    	layout2.addView(fileText);     	    	
  	        
    	layout.addView(layout2);
    	/** グラフ描画 **/
    	graph = new MyView(this);
        layout.addView(graph); 
        /** ボタンイベントリスナ生成 **/
	    Select.setOnClickListener((OnClickListener) new SelectExe());        
        Charge.setOnClickListener((OnClickListener) new ChargeCont());
        Save.setOnClickListener((OnClickListener) new SaveFile());
        Read.setOnClickListener((OnClickListener) new ReadFile());
        Delete.setOnClickListener((OnClickListener) new DeleteFile());
		/** Bluetoothが有効な端末か確認 **/
		BTadapter = BluetoothAdapter.getDefaultAdapter();
		if (BTadapter == null) {
			text1.setTextColor(Color.YELLOW);
			text1.setText("Bluetooth未サポート");
		}
    }
	/******* アクティビティ開始時（ストップからの復帰時） **********/
	@Override
	public void onStart() {
		super.onStart();
		if (BTadapter.isEnabled() == false) {		// Bluetoorhが有効でない場合
			/** Bluetoothを有効にするダイアログ画面に遷移し有効化要求 **/
			Intent BTenable = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
			/** 有効化されて戻ったらENABLEパラメータ発行 **/
			startActivityForResult(BTenable, ENABLEBLUETOOTH);
		}
		else {
			if (BTclient == null) {
				/** 有効化ならクライアントクラスを生成しハンドラを生成する **/
				BTclient = new BluetoothClient(this, handler);
			}
		}
	}
	/********* アクティビティ再開時（ポーズからの復帰時） **********/
	@Override
	public synchronized void onResume() {
		super.onResume();
		/** 特に処理なし **/
	}
	/****** アクティビティ破棄時 **********/
	@Override
	public void onDestroy() {
		super.onDestroy();
		if (BTclient != null) {
			BTclient.stop();
		}
	}
	/************ 遷移ダイアログからの戻り処理 *********************/
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
			/** 端末選択ダイアログからの戻り処理 **/
			case CONNECTDEVICE: 							// 端末が選択された場合
				if (resultCode == Activity.RESULT_OK) {
					String address = data.getExtras().getString(DeviceListActivity.DEVICEADDRESS);
					/** 生成した端末に接続要求 **/
					BluetoothDevice device = BTadapter.getRemoteDevice(address);
					BTclient.connect(device);				// 端末へ接続
				}
				break;
			/** 有効化ダイアログからの戻り処理 **/
			case ENABLEBLUETOOTH: 							// Bluetooth有効化の場合
				if (resultCode == Activity.RESULT_OK) {
					/** 正常に有効化できたらクライアントクラスを生成しハンドラを生成する **/
					BTclient = new BluetoothClient(this, handler);
				}
				else {
					Toast.makeText(this, "Bluetoothのサポートなし", Toast.LENGTH_SHORT).show();
					finish();
				}
		}
	}	
    /********* 接続ボタンイベントクラス ****************/
    class SelectExe implements OnClickListener{
    	public void onClick(View v){
 			/** デバイス検索と選択ダイアログへ移行 **/    		
    		Intent Intent = new Intent(ChargerController.this, DeviceListActivity.class);
 			/** 端末が選択されて戻ったら接続要求するようにする **/
 			startActivityForResult(Intent, CONNECTDEVICE);   	    		
    	}
    }
	/********** BT端末接続処理のハンドラ、戻り値ごとの処理 **********/
	private static final Handler handler = new Handler() {
		/** ハンドルメッセージごとの処理 **/
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
				case BluetoothClient.MESSAGE_STATECHANGE:
					switch (msg.arg1) {
						case BluetoothClient.STATE_CONNECTED:
							text1.setTextColor(Color.GREEN);
							text1.setText("接続完了");
							text2.setText("   ");
							break;
						case BluetoothClient.STATE_CONNECTING:
							text1.setTextColor(Color.WHITE);
							text1.setText("接続中");
							break;
						case BluetoothClient.STATE_NONE:
							text1.setTextColor(Color.RED);
							text1.setText("接続失敗");
							break;
					}
					break;
					/** BT受信処理 **/
				case BluetoothClient.MESSAGE_READ:
					RcvPacket = (byte[])msg.obj;
					Process();
					break;
			}
		}
	}; 
    /****  開始ボタンイベントクラス *********************************/
    class ChargeCont implements OnClickListener{
    	public void onClick(View v){
       		SndPacket[0] = 0x53;				// S
			SndPacket[1] = 0x4F;				// O
			SndPacket[2] = 0x45;				// E
			BTclient.write(SndPacket); 			// 送信実行 
			Index = 0;
			text1.setText(" ");
			text2.setText(" ");
    	}    		
    } 
	/******************* データ受信処理メソッド *********************/
	public static void Process(){
		/*** 受信チェック ***/
		if(RcvPacket[0] == 0x4D){									// M
			switch(RcvPacket[1]) {
				case 0x4F:											// O 
					if(RcvPacket[2] == 0x4B){						// K
						text1.setTextColor(Color.GREEN);
						text1.setText("モニタ開始");			
					}
					break;
				case 0x41:											// A 計測データ受信
					if(Index < 1560){
						/**** 受信データ格納 ******/
						temp = RcvPacket[2]*128 + RcvPacket[3];		// A/D変換値取得
						fTemp = (float)((temp * 489.9) / 4096);		// 電圧値に変換100倍
						ChargeVolt[Index] = (int)fTemp; 			// 整数に変換
						temp = RcvPacket[4]*128 + RcvPacket[5];		// A/D変換値取得
						fTemp = (float)((temp * 1532.0) / 4096);	// 電流値に変換
						ChargeCurrent[Index] = (int)fTemp;			// 整数に変換
						temp = RcvPacket[6]*128 + RcvPacket[7];	
						fTemp = (float)((temp * 489.9) / 4096);
						DischargeVolt[Index] = (int)fTemp; 
						temp = RcvPacket[8]*128 + RcvPacket[9];
						fTemp = (float)((temp * 4096.0)/ 4096);
						DischargeCurrent[Index] = (int)fTemp; 
						Index++;					
						/** グラフ表示実行 ***/
						handler.post(new Runnable(){
							public void run(){			
								graph.invalidate();					// データグラフの再表示	
							}
						});
					}
					/** 終了判定 ***/
					else{											// 表示終了チェック
						/* 終了コマンド送信 */
						SndPacket[0] = 0x53;						// S
						SndPacket[1] = 0x4E;						// N
						SndPacket[2] = 0x45;						// E
						BTclient.write(SndPacket); 					// 送信実行						
						text1.setTextColor(Color.MAGENTA);
						text1.setText("モニタ終了");
					}
					break;
				default:		// エラー
					break;
			}

		}
	}
    /***** データ保存イベントクラス *********************************/
  	Context context = this;
    class SaveFile implements OnClickListener{
    	public void onClick(View v){
    		if(Index == 0){
    			text2.setTextColor(Color.YELLOW);
    			text2.setText("データなし");
    		}
    		else{
	    		/** ファイル名取得  */
	    		String fileName = edText.getText().toString();
	    		OutputStream out = null;
	    		/** ファイル保存実行 **/
	    		try{
	    			out = context.openFileOutput(fileName, MODE_PRIVATE);
	    			/** データ数を保存 **/
	    			FileData[0] = (byte)(Index / 128);
	    			FileData[1] = (byte)(Index % 128);
	    			/** 全データをいったん変換 **/
	    			for(i=0; i<Index; i++){
	    				FileData[8*i+2]   = (byte)(ChargeVolt[i]/ 128);
	    				FileData[8*i+3] = (byte)(ChargeVolt[i] % 128);
	    				FileData[8*i+4] = (byte)(ChargeCurrent[i] / 128);
	    				FileData[8*i+5] = (byte)(ChargeCurrent[i] % 128);
	    				FileData[8*i+6] = (byte)(DischargeVolt[i] / 128);
	    				FileData[8*i+7] = (byte)(DischargeVolt[i] % 128);
	    				FileData[8*i+8] = (byte)(DischargeCurrent[i] / 128);
	    				FileData[8*i+9] = (byte)(DischargeCurrent[i] % 128);
	    			}
	    			/** 全データ一括保存 ***/
	     			out.write(FileData, 0, FileData.length);  			
	     			out.close();								// ファイルクローズ
	     			text2.setTextColor(Color.GREEN);			// メッセージ表示
	     			text2.setText("保存完了");
	     			/*** ファイルリスト表示 ***/
	        		String[] fileList = context.fileList();
	        		String editBody = "";
	        		for(String file: fileList){
	        			editBody = editBody + file+"\r\n";
	        		}
	        		fileText.setText(editBody);	     			
	    		}catch(Exception e){
	    			text2.setTextColor(Color.RED);
	    			text2.setText("保存失敗");
	    		}
    		}
    	}
    }
    /***** データ読み出し表示イベントクラス *************************/
    class ReadFile implements OnClickListener{
    	public void onClick(View v){
    		int size = 0;
    		InputStream in = null;
    		/** ファイル名取得 ***/
       		String fileName = edText.getText().toString();
       		/** ファイル読み出し **/
    		try{
    			in= context.openFileInput(fileName);
   				size = in.read(FileData);					// 配列数だけ読み出し
    			in.close();									// ファイルクローズ
    			text2.setTextColor(Color.GREEN);			// メッセージ表示
    			text2.setText("読出し完了 "+Integer.toString(size));
    		}catch(Exception e){							// エラーの場合
 				text2.setTextColor(Color.RED);				// メッセージ表示
				text2.setText("読出し失敗");
    		}
 			/*** ファイルリスト表示 ***/
    		String[] fileList = context.fileList();
    		String editBody = "";
    		for(String file: fileList){
    			editBody = editBody + file+"\r\n";
    		}
    		fileText.setText(editBody);	    		
    		/**** データに変換し格納 *******/
			Index = FileData[0] * 128 + FileData[1];		// データ数取り出し
			/*** 全データ変換 ***/
			for(i=0; i<Index; i++){
    			ChargeVolt[i]  = (int)(FileData[8*i+2]*128+FileData[8*i+3]);
    			ChargeCurrent[i] = (int)(FileData[8*i+4]*128+FileData[8*i+5]);
    			DischargeVolt[i] = (int)(FileData[8*i+6]*128+FileData[8*i+7]);
    			DischargeCurrent[i] = (int)(FileData[8*i+8]*128+FileData[8*i+9]);
			}   		
			/** グラフ表示実行 ***/
			handler.post(new Runnable(){
				public void run(){			
					graph.invalidate();						// データグラフの再表示	
				}
			});  		
    	}
    }
    /********** ファイル削除ボタンイベントクラス ********************/
    class DeleteFile implements OnClickListener{
    	public void onClick(View v){
			/** ファイル名取得 ***/
	   		String fileName = edText.getText().toString();
	   		/** ファイル削除 ***/
	   		try{
	   			deleteFile(fileName);
	   			text2.setTextColor(Color.GREEN);
	   			text2.setText("ファイル削除完了");
	 			/*** ファイルリスト表示 ***/
	    		String[] fileList = context.fileList();
	    		String editBody = "";
	    		for(String file: fileList){
	    			editBody = editBody + file+"\r\n";
	    		}
	    		fileText.setText(editBody);	
	   		}catch(Exception e){
	   			text2.setTextColor(Color.RED);
	   			text2.setText("ファイル削除失敗");
	   		}
    	}
   		
    }
	
	/********** グラフを描画するクラス   ****************************/
	Paint set_paint = new Paint();	
	class MyView extends View{
		/** Viewの初期化 ***/
		public MyView(Context context){
			super(context);
 		}
		/** グラフ描画実行メソッド **/
		public void onDraw(Canvas canvas)	{
	 		super.onDraw(canvas);

	 		/** 背景色の設定 **/	 		
			canvas.drawColor(Color.BLACK); 
			/** 座標の表示 青色で表示 **/			
			set_paint.setColor(Color.BLUE);
			set_paint.setStrokeWidth(1);
			for(i=0; i<14; i++)									// 縦軸の表示　15本
				canvas.drawLine(35+i*120, 30, 35+i*120, 1030, set_paint);
			for(i=0; i<10; i++)									// 横軸の表示　10本
				canvas.drawLine(35, i*100+30, 1595, i*100+30, set_paint);
			/** 外枠ライン白色で描画 **/
			set_paint.setColor(Color.WHITE);
			set_paint.setStrokeWidth(2);   		
			canvas.drawLine(35, 30, 35, 1030, set_paint);
			canvas.drawLine(1595, 30, 1595, 1030, set_paint);
			canvas.drawLine(35, 30, 1595, 30 ,set_paint);
			canvas.drawLine(35, 1030, 1595, 1030, set_paint);			
			/** 軸目盛の表示 **/			
			set_paint.setAntiAlias(true);
			set_paint.setTextSize(20f);
			set_paint.setColor(Color.WHITE);
			for(i=0; i<=13; i++)								// X座標目盛
	    		canvas.drawText(Integer.toString(i*30), 20+i*120, 1055, set_paint);
			for(i=0; i<=10; i++)								// Y座標目盛
				canvas.drawText(Integer.toString(i*5), 5, 1035-i*100, set_paint);
			/** 軸表題表示 **/
			set_paint.setTextSize(25f);
			set_paint.setColor(Color.CYAN);
			canvas.drawText("分", 680, 1065, set_paint);			
			canvas.drawText("電", 0, 470, set_paint);
			canvas.drawText("圧", 0, 495, set_paint);
			set_paint.setColor(Color.MAGENTA);			
			canvas.drawText("電", 0, 570, set_paint);
			canvas.drawText("流", 0, 595, set_paint);			
			/** グラフ説明表示 **/
			set_paint.setColor(Color.RED);
			canvas.drawText("充電電流", 140, 1010, set_paint);
			set_paint.setColor(Color.GREEN);
			canvas.drawText("充電電圧", 280, 1010, set_paint);
			set_paint.setColor(Color.MAGENTA);
			canvas.drawText("放電電流", 450, 1010, set_paint);			
			set_paint.setColor(Color.YELLOW);
			canvas.drawText("放電電圧", 580, 1010, set_paint);
			/** 実際のグラフの表示 **/
			set_paint.setStrokeWidth(2);			
  			for(j=1; j<Index; j++){ 				
				set_paint.setColor(Color.GREEN);	
		 		canvas.drawLine(j+35, 1030-ChargeVolt[j-1]*2, j+36,
		 							1030-ChargeVolt[j]*2, set_paint);
 				set_paint.setColor(Color.RED);
		 		canvas.drawLine(j+35, 1030-ChargeCurrent[j-1]*2, j+36,
		 						    1030-ChargeCurrent[j]*2, set_paint);		 		
				set_paint.setColor(Color.YELLOW);			
		 		canvas.drawLine(j+35, 1030-DischargeVolt[j-1]*2, j+36,
		 							1030-DischargeVolt[j]*2, set_paint);	
				set_paint.setColor(Color.MAGENTA);			
		 		canvas.drawLine(j+35, 1030-DischargeCurrent[j-1]*2, j+36,
		 							1030-DischargeCurrent[j]*2, set_paint);		 		
 			}
		}
    }		
}


